{*************************************************************
* (C) 2012 HannoWare.com, Inc.                               * 
* Conduit 1/2012                                         *
**************************************************************}
CON
    _clkmode = xtal1 + pll16x
    _clkfreq = 80_000_000
    BUF_SIZE      = 32          
    pp=16
VAR
  long packet_num    
  long packet_delay
  long cfgs[6]
  long dats[9]
  
  word  txterm
  word enqueue, dequeue
  byte  buffer[BUF_SIZE]

PUB main|a,b,c {example program}
  monitorina(@a) 
  config(string("edit:v3(mode=[dial])"))
  rxtx(0,1)
  share(@a,@c)
  dira[16]~~
  repeat
    !outa[16]
    b:=rx
    str(string("you typed a"))
    char(b)
pub rxtx(_rx,_tx)
  rxpin:=_rx
  txpin:=_tx      
PUB share(firstVarPtr,lastVarPtr)|arrayLen
{{
Share memory from varA to varC with ViewPort. This lets you
monitor&change them.  You MUST use this function- at the start of your
program, but AFTER "register" and "config" statements have run.  
}}
  if lastVarPtr
    array(firstVarPtr,(lastVarPtr-firstVarPtr+4)>>2,1)
  waitcnt(cnt+clkfreq/10)
  start(rxpin,txpin)
  waitcnt(cnt+clkfreq/100)         
  return @packet_num    
pub monitorINA(_ioptr) {Continually updates _io with value of ina, useful if not using quicksample}
  io_addr:=_ioptr
pub array(arrayPtr,arrayLen,arrayType) 
{Share an array of length arrayLen longs.  Type should be >3 for user data}
  dats[shareNum]:=arrayPtr<<16+arrayLen    
  sharetype|=arrayType<<(shareNum*3+8) 
  shareNum:=(shareNum+1)//8     
pub update {sends one packet every time update is called, useful for video}
  packet_delay~ 
  packet_delay:=1
  waitpacket
pub waitpacket|lastpacket {wait for next packet to start}
  lastpacket:=packet_num
  repeat while packet_num==lastpacket   
pub register(mPtr)|mode,cfg,len,ncog
{{
Register other components (fuzzy logic, video, quicksample..)
}}
   
   
   
   
  mode:=mptr & 3
  mPtr-=mode
  cfg:=long[mPtr]
  case mode
    0:    
      extra|=cfg 
      case cfg
        1..3:len:=6001 
        4:len:=3001
        5,6:len:=1501
        7,8:len:=120*40+1                  
        9,10:len:=120*35+1
    2: 
   
      startqs:=cfg               
      ncog:=long[mPtr+12]+1    
      qscog_num+=ncog
      long[mPtr+24]:=@packet_num      
      if ncog==5
        ncog-=1
        len:=4*268+9     
        startps:=long[mPtr+8]
        psadd2+=1        
      else


        psinit~     
        len:=ncog*360+6
        io_addr:=mptr+32
    3:
   
      len:=cfg/4
  array(mPtr,len,mode)
PUB debug(dP1,dP2) {Used by ViewPort debugger}
  array(dP1,6,4)
  dbg_addr:=dP2  
pub txtermAdr
    return @txterm
pub config(sptr) {Configure ViewPort.  CfgString can be generated by ViewPort.}
  configlen(sptr,strsize(sptr))
pub configlen(sptr,len)
  long[@cfgs+cfgNum<<2]:=sptr<<16+len
  cfgNum:=(cfgNum+1)//6
''-------[ Initialization ]----------------------------------------------------
pri start(rx_pin, tx_pin) | i
  inp_mask := 1 << rx_pin
  out_mask := 1 << tx_pin
  out_imask:= -1-out_mask
  timeout := clkfreq /2/12 
  _100ms := clkfreq / 10
  _10ms := clkfreq / 100
  _650ns := (clkfreq / 1538461) #> 16
  _1300ns := _650ns << 1  
  txterm~
  delay_addr:=@packet_delay
  txterm_addr:=@txterm
  cfg_addr:=@cfgs
  dat_addr:=@dats
  enq_addr:=@enqueue
  deq_addr:=@dequeue
  buf_addr:=@buffer  
  cognew(@main_lp, @packet_num)
  return true
PUB rx  { Return the next byte from the input queue. This methods blocks if no bytes are available.}  
  repeat while (enqueue == dequeue)
  result := buffer[dequeue]
  dequeue := (dequeue + 1) // BUF_SIZE
PUB rxavailable {Return number of bytes available for rx}
  return enqueue - dequeue + (BUF_SIZE & (enqueue < dequeue))  
PUB str(stringptr) {send a string to VP}
  repeat strsize(stringptr)
    char(byte[stringptr++])
PUB char(t) {send a byte to vp}
  repeat while txterm>0  
  txterm:=t<<8+$a5 
  
DAT
main_lp     
'xbee rts
      or dira,xbrts'        dira[xrts]~~
'      outa[xrts]~
      
      
       call #dorx
       jmp #main_lp

dorx 
           mov ptr,#0
           
           mov acc,cnt
         
    :nomatch  mov idx,#2   
       :lp1 
      
      
      
              waitpne inp_mask,inp_mask
              waitpeq inp_mask,inp_mask'look for high              
              mov accx,cnt
      
              mov baud,accx              
             sub baud,acc 
             mov acc,accx 
              mov accx,baud
              subs accx,ptr
              abs accx,accx
      
              cmp accx,#10 wc 
      
              mov ptr,baud  
              
       if_nc  jmp #:nomatch                    
              
              djnz idx,#:lp1
     
       
            
       shr baud,#1
      
            
       mov halfbit,baud
       shr halfbit,#1
       sub halfbit,#34
       
                         
       
       
              call      #serin 
    
              cmp acc,#10 wz 
      if_z    jmp #doterm
              cmp acc,#11 wz 
      if_z    jmp #dolong
              cmp acc,#12 wz 
      if_z    jmp #doread        
              mov idx,acc
              call #rxok
              cmp idx,#8 wc
              add idx,#cmdtbl
                     
  
  if_c_and_z  jmp idx
  cmdtbl      jmp #rxtimeout
              jmp #doload  
              jmp #dodat   
              jmp #doqs    
              jmp #dobkpt  
              jmp #domem   
              and dira,out_imask
              call #docfg
              jmp #main_lp
             
  dorx_ret    ret              
rxtimeout    
                       
              jmp #dorx_ret
dobkpt                  
              mov     ptr,dbg_addr
              add     ptr,#4      
              rdlong  idx,ptr     
              mov     acc,#0
              wrlong  acc,ptr     
              mov accx,cnt
              add accx,spinticks
              waitcnt accx,#0     
              wrlong  idx,ptr     
              wrlong  acc,dbg_addr
              jmp     #dorx_ret
domem      mov txmem,#1  
        jmp #dorx_ret            
doqs          mov     acc,startqs   
   qscog_num  mov     accx,#0   
   qslp       coginit acc nr  
psadd2        add     acc,#1   
              djnz    accx,#qslp              
   psinit     coginit startps nr     
              jmp #dorx_ret
docfg        
              or dira,out_mask 
        
              mov txb,#1
              call #txlong  
              call #txmarker            
              mov txb,sharetype
              call #txlong
              mov txb,extra
              call #txlong
              rdlong txb,#0 
              call #txlong  
              mov txidx,cfg_addr 
              mov idx2,#6
     :lp      rdword txcount,txidx'read length of slice
              mov txb,txcount 
              call #txword   
              
              add txidx,#2     
              tjz txcount,#:nostr
              rdword txptr,txidx
    :lp2      rdbyte txb,txptr
              call #txbyte    
              add txptr,#1
              djnz txcount,#:lp2   
     :nostr   add txidx,#2
              djnz idx2,#:lp              
              mov idx,dat_addr
              mov idx2,#8
       :lp3   rdlong txb,idx
              call #txlong
              add idx,#4
              djnz idx2,#:lp3
              call #txmarker
  docfg_ret   ret
             
   dodat      or sharetype,#1 
             
    datlp        
           mov txb,markerdat
              call #txword
              mov txframe,#257
              tjz io_addr,#noioptr 
              mov idx,ina              
              wrlong idx,io_addr                            
    noioptr   mov idx,cnt      
              wrlong idx,par 
              
              
              rdlong  acc,delay_addr wz 
        if_nz call #dodelay                 
     nowait   mov txidx,dat_addr   
      :lp     rdword txcount,txidx wz'read length of slice      
      if_nz   jmp #:lp0
             
              rdword    txb,txterm_addr wz  
      if_nz   wrword _0,txterm_addr
      if_nz   call #txword
              tjz txmem,#datlp
             
              mov txb,#$ac
              call #txbyte 
              mov txcount,#32
               
              mov txidx,#0
       :mlp2  mov txb,#26
              call #txbyte
              mov txframe,#256
      :mlp    rdlong txb,txidx          
              call #txlong
              add txidx,#4
              djnz txframe,#:mlp
              djnz txcount,#:mlp2
              mov txmem,#0
              jmp #datlp
              
              
     :lp0     add txidx,#2     
              rdword txptr,txidx
    :lp1      djnz txframe,#:lp2
              mov txb,#26
              call #txbyte
              mov txframe,#256
     :lp2     rdlong txb,txptr
    
              call #txlong    
              add txptr,#4
              djnz txcount,#:lp1   
              add txidx,#2            
              jmp #:lp
dodelay
        rdlong  acc,delay_addr wz 
        test      inp_mask,ina wc      
 if_c_and_nz  jmp #dodelay    
           wrlong delay_addr,delay_addr          
dodelay_ret   ret             
doterm        call #rxcount 
       :lp    call #serin
              call #buf_acc               
              djnz count,#:lp
              call #rxok              
              jmp #dorx_ret              
doRead      
              call #rxcount
              mov txb,markerdat
              call #txword
              rdlong txb,count              
              call #txbyte
              call #txlong
              jmp #dodat                            
dolong       
             
              call #rxcount  
              mov lng,#0
              mov idx,#4
        :lp   call #serin
              or lng,acc
              ror lng,#8
              djnz idx,#:lp
              call #rxok              
              wrlong lng,count
              jmp #dorx_ret
rxcount       call #serin
              mov count,acc              
              call #serin
              shl acc,#8
              or count,acc
 rxcount_ret  ret
rxok          call #serin
              cmp acc,#20 wz
     rxok_ret ret
doload    
              mov       sertimeout,jmpmon                          
              mov       accx,#7
              cogid     acc
   halt_lp    cmp       accx,acc wz           
        if_nz cogstop   accx
              sub       accx,#1 wc
        if_nc jmp       #halt_lp
            
monitorlp     call      #prompt                

waitcmd       test      inp_mask,ina wc
       if_c   jmp #waitcmd
              mov       inp_time,cnt           
              call      #serin_mon             
              cmp       acc,#"#" wz            
        if_nz jmp       #monitorlp               

              call      #serin_mon             
             
              cmp       acc,#$a5 wz            
        if_z  jmp       #tstldram              

              cmp       acc,#$aa wz            
        if_z  jmp       #tstldrom              
                    
              cmp       acc,#"?" wz            
        if_nz jmp       #tstxeq                

              jmp       #monitorlp             

tstxeq        cmp       acc,#"!" wz            
        if_z  jmp       #boot_ram              
              jmp       #report_err            

 {Code from Phil Pilgrim's XBEE Loader}
tstldram      call      #serin_mon             

              cmp       acc,#$5a wz            
        if_nz jmp       #report_err            
get_ram      
              call      #serin_mon             
              mov       count,acc
              call      #serin_mon             
              shl       acc,#8
              or        count,acc 
              
              cmp       count,_0x8000 wz,wc    
 if_nz_and_nc jmp       #report_err            

             
              mov       chksum,#0              
              mov       ram_addr,#0            

:getloop      call      #serin_mon             
              add       chksum,acc             
              wrbyte    acc,ram_addr           
              add       ram_addr,#1            
              djnz      count,#:getloop        
and chksum,#255
cmp chksum,#20 wz

      
        if_nz jmp       #restore_err           
:zeroloop     cmp       ram_addr,_0x8000 wc    
        if_nc jmp       #monitorlp             
              wrlong    _0,ram_addr            
              add       ram_addr,#4            
              jmp       #:zeroloop             


tstldrom      call      #serin_mon             
              cmp       acc,#$55 wz            
        if_nz jmp       #report_err            

              or        outa,scl_pin
              or        dira,scl_pin

save_rom      call      #delay10ms             
              mov       ee_addr,#0             
              mov       ram_addr,#0            
              mov       pgcount,_0x8000        
              shr       pgcount,#6             

:pagelp       call      #i2c_waddr             
              mov       count,#64              
              test      ee_addr,#$1ff wz       
        if_z  call      #progress              

:bytelp       rdbyte    acc,ram_addr           
              add       ram_addr,#1            
              call      #i2c_wr                
              djnz      count,#:bytelp         

              call      #i2c_stop              
              add       ee_addr,#64            
              djnz      pgcount,#:pagelp       

              call      #delay10ms             
              call      #cmprom                
        if_nz jmp       #report_err            
                        
              call      #prompt                
              call      #delay100ms            
              clkset    reeboot                
                           
restore_err   call      #getrom                
report_err    call      #delay10ms             
              mov       txb,#"?"               
              call      #txbyte
              jmp       #monitorlp


boot_ram      rdbyte    acc,#$0004             
              and       acc,#$F8               
              clkset    acc
:delay        djnz      time_xtal,#:delay      
              rdbyte    acc,#$0004             
              clkset    acc
              cogid     acc              
              coginit   interpreter            
              cogstop   acc

getrom        mov       wr_ram,#1              
              jmp       #allrom

cmprom        mov       wr_ram,#0              

allrom        mov       ee_addr,#0             
              mov       ram_addr,#0            
              mov       count,_0x8000          
              call      #i2c_waddr             
              call      #i2c_start             
              mov       acc,#%1010_000_1       
              call      #i2c_wr

:readlp       call      #i2c_rd_ack            
              tjnz      wr_ram,#:wbyte         
        
              rdbyte    accx,ram_addr          
              cmp       acc,accx wz            
        if_nz jmp       #getrom_ret            

              jmp       #:next                 

:wbyte        wrbyte    acc,ram_addr           

:next         add       ram_addr,#1            
              cmpsub    ram_addr,_0x8000       
              djnz      count,#:readlp         

              call      #i2c_rd_nak            
              call      #i2c_stop              

cmprom_ret
gethirom_ret
getrom_ret    ret                              



serin_mon
serin         mov       inp_time,timeout  
           mov       bit_time,halfbit 
   
   
   
  :lp      test      inp_mask,ina wc        
       if_c jmp #:lp'  djnz      inp_time,#:lp              
       if_nc   jmp       #get_char
  sertimeout  jmp       #dorx_ret               

 get_char     call      #serin0                
serin_mon_ret
serin_ret     ret                              
 jmpmon       jmp #waitcmd


serin0                 
              add       bit_time,cnt
              waitcnt   bit_time,baud
              test      inp_mask,ina wc        
        if_c  jmp       serin0_ret             
        
              mov       acc,#0                 
              mov       bit_cnt,#8             
              
:bitlp        
              waitcnt   bit_time,baud          
              test      inp_mask,ina wc        
        if_c  or        acc,#$100              
              shr       acc,#1                 
              djnz      bit_cnt,#:bitlp        
              
              waitpeq inp_mask,inp_mask        
serin0_ret    ret 

prompt
              or dira,out_mask
'              call      #delay10ms             
              mov       txb,#42               
              call      #txbyte
   prompt_ret ret
txlong        call #txword
              call #txword
   txlong_ret ret           
txmarker      mov txb,marker              
txword        call #txbyte  
              call #txbyte
   txmarker_ret
   txword_ret ret
progress      
              mov       txb,#"."               
              jmp       #txbyte   
txbyte       

              mov       bit_time,cnt                    
              add       bit_time,baud          
              and       outa,out_imask         
              mov       bit_cnt,#8 wz 
   :bits      waitcnt   bit_time,baud          
              shr       txb,#1 wc              
              muxc      outa,out_mask          
      if_nz   test      inp_mask,ina wz        
              djnz      bit_cnt,#:bits         
              waitcnt   bit_time,baud          
              or        outa,out_mask          
        if_nz waitcnt   bit_time,baud          
        if_z  call #dorx
progress_ret      
txbyte_ret    ret

buf_acc       mov       ram_addr,buf_addr          
              add       ram_addr,buf_enq           
              wrbyte    acc,ram_addr               
              mov       acc,buf_enq            
              add       acc,#1                 
              cmp       acc,buf_len wz         
        if_z  mov       acc,#0                 
              rdword    buf_deq,deq_addr       
              cmp       acc,buf_deq wz         
        if_nz wrword    acc,enq_addr           
        if_nz mov       buf_enq,acc            
        
buf_acc_ret   


i2c_waddr     call      #i2c_start             
              mov       acc,#%1010_000_0       
              call      #i2c_wr                
        if_c  jmp       #i2c_waddr             
        
              mov       acc,ee_addr            
              shr       acc,#8
              call      #i2c_wr                
              mov       acc,ee_addr            
              call      #i2c_wr                
i2c_waddr_ret ret                              

i2c_rd_nak    test      _0x8000,_0x8000 wc     
              jmp       #i2c_rd


i2c_rd_ack    test      _0x8000,#0 wc          


i2c_rd        mov       acc,#$ff               
              jmp       #i2c_rd_wr

i2c_wr        test      _0x8000,_0x8000 wc     


i2c_rd_wr     mov       bit_cnt,#9             
              rcl       acc,#24                

:wrlp         rcl       acc,#1 wc              
              muxnc     dira,sda_pin           
              call      #delay650              
              or        outa,scl_pin           
              call      #delay650              
              test      sda_pin,ina wc         
              andn      outa,scl_pin           
              call      #delay650              
              djnz      bit_cnt,#:wrlp         

              and       acc,#$ff               
i2c_rd_ack_ret
i2c_rd_nak_ret
i2c_rd_ret
i2c_wr_ret    ret

i2c_start     andn      dira,sda_pin           
              call      #delay650              
              or        outa,scl_pin           
              call      #delay650              
              or        dira,sda_pin           
              call      #delay650              
              andn      outa,scl_pin           
              call      #delay650              
i2c_start_ret ret


i2c_stop      andn      outa,scl_pin           
              call      #delay650              
              or        dira,sda_pin           
              call      #delay650              
              or        outa,scl_pin           
              call      #delay650              
              andn      dira,sda_pin           
              call      #delay650              
i2c_stop_ret  ret

delay100ms    mov       bit_time,_100ms
              jmp       #delay

delay10ms     mov       bit_time,_10ms
              jmp       #delay

delay1300     mov       bit_time,_1300ns
              jmp       #delay

delay650      mov       bit_time,_650ns
              jmp       #delay

delay         add       bit_time,cnt
              waitcnt   bit_time,#0
delay_ret
delay100ms_ret
delay10ms_ret
delay650_ret
delay1300_ret ret 

sharetype     long      8
buf_len       long      BUF_SIZE
buf_enq       long      0
buf_deq       long      0
time_xtal     long      20 * 20000 / 4 / 1      
interpreter   long      $0001 << 18 + $3C01 << 4
scl_pin       long      1 << 28
sda_pin       long      1 << 29
reeboot       long      $80
_0            long      0
_0x300        long      $300
_0x100        long      $100
_0x8000       long      $8000
_100ms        long      0-0
_10ms         long      0-0
_650ns        long      0-0
_1300ns       long      0-0
inp_mask      long      0-0
out_mask      long      0-0
out_imask      long      0-0
timeout       long      0-0
io_addr       long      0
dbg_addr      long 0
delay_addr    long 0
txterm_addr     long       1
cfg_addr      long       1
dat_addr      long       1
buf_addr      long       1
enq_addr      long       1
deq_addr      long       1
startqs       long 0
extra         long 0
txdelay long 1_000_000
startps       long 0
spinticks  long 2_000
txmem         long      0
xbrts         long 1<<15

marker        word      $a55a
cfgnum        byte      0
sharenum      byte      0
markerdat     word      $1a5b
rxpin         byte      31
txpin         byte      30 
baud res 1
txcount res 1
txb res 1
txidx res 1
txptr res 1
halfbit res 1


ptr           res       1
bit_time      res       1
inp_time      res       1
idx           res       1
lng           res       1
acc           res       1
accx          res       1
bit_cnt       res       1   
rand          res       1
ram_addr      res       1
ee_addr       res       1
count         res       1
pgcount       res       1
chksum        res       1
wr_ram        res       1
idx2          res       1
txframe       res       1
           

              fit
              